export enum Rarity {
	COMMON = 0,
	UNCOMMON = 1,
	RARE = 2,
	LEGENDARY = 3,
}

export enum Quota {
	QA_NONE = 0,
	QA_LOW = 1,
	QA_MEDIUM = 2,
	QA_HIGH = 3,
	QA_VERY_HIGH = 4,
}

export enum ArtifactPolarity {
	AP_UNIVERSAL = 0,
	AP_ATTACK = 1,
	AP_DEFENSE = 2,
	AP_TACTIC = 3,
	AP_POWER = 4,
	AP_PRECEPT = 5,
	AP_FUSION = 6,
	AP_WARD = 7,
	AP_UMBRA = 8,
	AP_ANY = 9,
}

export enum DamageType {
	DT_IMPACT = 0,
	DT_PUNCTURE = 1,
	DT_SLASH = 2,
	DT_FIRE = 3,
	DT_FREEZE = 4,
	DT_ELECTRICITY = 5,
	DT_POISON = 6,
	DT_EXPLOSION = 7,
	DT_RADIATION = 8,
	DT_GAS = 9,
	DT_MAGNETIC = 10,
	DT_VIRAL = 11,
	DT_CORROSIVE = 12,
	DT_RADIANT = 13,
	DT_SENTIENT = 14,
	DT_CINEMATIC = 15,
	DT_SHIELD_DRAIN = 16,
	DT_HEALTH_DRAIN = 17,
	DT_ENERGY_DRAIN = 18,
	DT_FINISHER = 19,
	DT_SUICIDE = 20,
	DT_PHYSICAL = 21,
	DT_INVALID = 22,
	DT_BASE_ELEMENTAL = 23,
	DT_COMPOUND_ELEMENTAL = 24,
	DT_ANY = 25,
}

export enum OperationType {
	ADD = 0,
	MULTIPLY = 1,
	STACKING_MULTIPLY = 2,
	SET = 3,
	ADD_BASE = 4,
}

export enum UpgradeType {
	NONE,
	AVATAR_ABILITY_AUGMENT,
	AVATAR_ABILITY_DURATION,
	AVATAR_ABILITY_EFFICIENCY,
	AVATAR_ABILITY_ENERGY_TO_OVERSHIELD,
	AVATAR_ABILITY_ENERGY_TO_SHIELD,
	AVATAR_ABILITY_RANGE,
	AVATAR_ABILITY_STRENGTH,
	AVATAR_ABILITY,
	AVATAR_ACROBATIC_SPEED,
	AVATAR_AFTERBURNER_MULTIPLIER,
	AVATAR_AIM_TIME,
	AVATAR_AIR_JUMP_HEIGHT,
	AVATAR_ARMOUR,
	AVATAR_AURA_EFFECTIVENESS_ON_ME,
	AVATAR_AURA_STRENGTH,
	AVATAR_AUTO_PARRY_CHANCE,
	AVATAR_BLEEDOUT_MODIFIER,
	AVATAR_BULLET_DODGE_ANGLE,
	AVATAR_BULLET_DODGE_CHANCE,
	AVATAR_CARRY_CAPACITY,
	AVATAR_CASTING_SPEED,
	AVATAR_CROWD_CONTROL_DAMAGE,
	AVATAR_CROWD_CONTROL_TIME_MULTIPLIER,
	AVATAR_DAMAGE_POWER_MULTIPLIER,
	AVATAR_DAMAGE_REDUCTION_DURING_REVIVE,
	AVATAR_DAMAGE_TAKEN,
	AVATAR_DASH_CONTACT_ENERGY,
	AVATAR_DASH_DAMAGE,
	AVATAR_DASH_RADIUS,
	AVATAR_DODGE_COOLDOWN,
	AVATAR_DODGE_COST_MULTIPLIER,
	AVATAR_DODGE_SPEED,
	AVATAR_DROP_CHANCE_MODIFIER,
	AVATAR_ENEMY_RADAR,
	AVATAR_ENERGY_GAIN_MULTIPLIER,
	AVATAR_ENERGY_ON_FULL_SHIELD_REGEN,
	AVATAR_ENERGY_SPAWN_PERCENT,
	AVATAR_ENERGY_TO_OVERSHIELDS_ON_SPAWN,
	AVATAR_EVADE_NPC_BULLET,
	AVATAR_EXPLOSION_DAMAGE,
	AVATAR_EXPLOSION_RADIUS,
	AVATAR_FALL_DAMAGE,
	AVATAR_FALL_IMPACT_AMOUNT,
	AVATAR_FALL_IMPACT_RADIUS,
	AVATAR_FORCED_PROC_CHANCE,
	AVATAR_FREEZE_ON_MELEE_HIT_CHANCE,
	AVATAR_FREEZE_ON_MELEE_HIT_DURATION,
	AVATAR_FULL_ENERGY_EFFECT_RANGE,
	AVATAR_GLOBAL_DROP_CHANCE_MODIFIER,
	AVATAR_GLORY_KILL_CHANCE,
	AVATAR_GLORY_KILL_HEALTH_RANGE,
	AVATAR_HACK_CHANCE,
	AVATAR_HEAL_PERCENT_MAX_HEALTH,
	AVATAR_HEAL_RATE_FORCED,
	AVATAR_HEAL_RATE,
	AVATAR_HEALTH_MAX,
	AVATAR_HEAVY_LAND_SPEED,
	AVATAR_INJURY_ANIM_RATE,
	AVATAR_INJURY_BLOCK_CHANCE_CC,
	AVATAR_INJURY_BLOCK_CHANCE,
	AVATAR_JOG_SPEED,
	AVATAR_JUMP_HEIGHT,
	AVATAR_KNOCKDOWN_RECOVERY_SPEED,
	AVATAR_LOOT_CHANCE,
	AVATAR_LOOT_RADAR,
	AVATAR_MARKED_DAMAGE_AMOUNT,
	AVATAR_MELEE_DAMAGE_REDUCTION,
	AVATAR_MELEE_DAMAGE_TO_JUMP_KICK,
	AVATAR_MOVEMENT_ACCELERATION,
	AVATAR_MOVEMENT_SPEED,
	AVATAR_NO_DEATH_PENALTY,
	AVATAR_NPC_HIT_CHANCE,
	AVATAR_NPC_VIS_RANGE,
	AVATAR_NUM_JUMPS,
	AVATAR_OVERSHIELD_MAX,
	AVATAR_PARKOUR_BOOST,
	AVATAR_PARKOUR_BULLET_TIME,
	AVATAR_PARKOUR_DAMAGE_ADDED,
	AVATAR_PARKOUR_GLIDE,
	AVATAR_PARKOUR_GRAVITY,
	AVATAR_PARKOUR_SLAM_ENERGY_COST,
	AVATAR_PICKUP_BONUS_AMOUNT,
	AVATAR_POWER_MAX,
	AVATAR_POWER_RATE_PERCENT_MAX,
	AVATAR_POWER_RATE,
	AVATAR_PROC_DAMAGE,
	AVATAR_PROC_IMMUNITY_DURATION,
	AVATAR_PROC_REFLECT_AMPLIFICATION,
	AVATAR_PROC_REFLECT_CHANCE,
	AVATAR_PROC_TIME,
	AVATAR_RAGE_BURN_RATE,
	AVATAR_REHACK_CHANCE,
	AVATAR_RESPAWN_TIME,
	AVATAR_REVENGE_DAMAGE_AMOUNT,
	AVATAR_REVENGE_DAMAGE_CHANCE,
	AVATAR_REVIVE_ASSIST,
	AVATAR_REVIVE_DISTANCE,
	AVATAR_REVIVE_SPEED,
	AVATAR_SENTINEL_ARMOUR_LINK,
	AVATAR_SENTINEL_CRIT_LINK,
	AVATAR_SENTINEL_FINISHER_DAMAGE,
	AVATAR_SENTINEL_HEALTH_LINK,
	AVATAR_SENTINEL_MASTER_BLEEDOUT_MODIFIER,
	AVATAR_SENTINEL_PACK_LEADER_REVERSE,
	AVATAR_SENTINEL_PACK_LEADER,
	AVATAR_SENTINEL_PICKUP_TO_ARMOR,
	AVATAR_SENTINEL_SHIELD_LINK,
	AVATAR_SENTINEL_STATUS_LINK,
	AVATAR_SHARE_ENERGY_PICKUP_RADIUS,
	AVATAR_SHARE_XP_RADIUS,
	AVATAR_SHIELD_GATE_DURATION,
	AVATAR_SHIELD_MAX,
	AVATAR_SHIELD_RECHARGE_DELAY,
	AVATAR_SHIELD_RECHARGE_PERCENT,
	AVATAR_SHIELD_RECHARGE_RATE,
	AVATAR_SHIELD_REDIRECTION,
	AVATAR_SHIELD_STAMINA_COST_MULTIPLIER,
	AVATAR_SHIELD_TO_STAMINA_RATIO,
	AVATAR_SLIDE_BOOST,
	AVATAR_SLIDE_FRICTION,
	AVATAR_SOFT_TARGETING_RADIUS_MODIFIER,
	AVATAR_SPAWN_ENERGY,
	AVATAR_SPRINT_SPEED,
	AVATAR_STAMINA_COST_MULTIPLIER,
	AVATAR_STAMINA_MAX,
	AVATAR_STAMINA_RECHARGE_DELAY,
	AVATAR_STAMINA_RECHARGE_RATE,
	AVATAR_STEALTH_FULL_OCCLUSION_RADIUS,
	AVATAR_STEALTH_MIN_OCCLUSION_RADIUS,
	AVATAR_STUN_TIME,
	AVATAR_SUCCESS_CHANCE,
	AVATAR_THORNS_PERCENT,
	AVATAR_TIME_LIMIT_INCREASE,
	AVATAR_TIME_TO_CLOAK,
	AVATAR_WALLCLING_TIME,
	AVATAR_WALLJUMP_HEIGHT,
	AVATAR_WALLRUN_SPEED,
	GAMEPLAY_BULLET_KILL_XP_AMOUNT,
	GAMEPLAY_DAMAGE_TO_POWER,
	GAMEPLAY_ENEMY_AVATAR_XP_REWARD,
	GAMEPLAY_ENEMY_SPAWN_CHANCE,
	GAMEPLAY_EXECUTION_HEALTH_THRESHOLD,
	GAMEPLAY_FACTION_DAMAGE_RESISTANCE,
	GAMEPLAY_FACTION_DAMAGE,
	GAMEPLAY_FACTION_SHIELD_DAMAGE_RESISTANCE,
	GAMEPLAY_FINISHER_XP_AMOUNT,
	GAMEPLAY_FREE_REVIVE_COUNT,
	GAMEPLAY_GEAR_ITEM_COOLDOWN,
	GAMEPLAY_HEALTH_ON_DEATH,
	GAMEPLAY_ITEM_EFFECTIVENESS,
	GAMEPLAY_KILL_POWER_AMOUNT,
	GAMEPLAY_KILL_POWER_COOLDOWN,
	GAMEPLAY_KILL_XP_AMOUNT,
	GAMEPLAY_KILL_XP_REWARD,
	GAMEPLAY_MAX_HEALTH_SEGMENT_REWARD,
	GAMEPLAY_MELEE_KILL_XP_AMOUNT,
	GAMEPLAY_MONEY_DROP_AMOUNT,
	GAMEPLAY_MONEY_PICKUP_AMOUNT,
	GAMEPLAY_MONEY_REWARD_AMOUNT,
	GAMEPLAY_NON_HUMAN_DAMAGE_RESISTANCE,
	GAMEPLAY_PICKUP_AMOUNT,
	GAMEPLAY_PICKUP_RATE,
	GAMEPLAY_POWER_COOLDOWN,
	GAMEPLAY_POWER_TO_HEALTH_ON_DEATH,
	GAMEPLAY_SHIELD_UPGRADE_LEVEL,
	VEHICLE_DOUBLE_JUMP_HEIGHT,
	VEHICLE_FALL_RESIST_CHANCE,
	VEHICLE_FALL_SPEED,
	VEHICLE_JUMP_CHARGE_TIME,
	VEHICLE_JUMP_HEIGHT,
	VEHICLE_MAGNETISM,
	VEHICLE_SCORE_MULTIPLIER,
	VEHICLE_SPEED_ALT,
	VEHICLE_SPEED,
	VEHICLE_SPRINT_SPEED,
	WEAPON_AIMED_SHOT_DAMAGE_BONUS,
	WEAPON_AMMO_CONSUME_RATE,
	WEAPON_AMMO_FREE_CHANCE,
	WEAPON_AMMO_MAX,
	WEAPON_AMMO_RETRIEVED,
	WEAPON_AUGMENT,
	WEAPON_BATTERY_REGEN_RATE,
	WEAPON_BODYSHOT_MULTIPLIER,
	WEAPON_BONUS_NORMALIZED_ELEMENTAL_DAMAGE,
	WEAPON_BONUS_NORMALIZED_PHYSICAL_DAMAGE,
	WEAPON_BYPASS_SHIELD_ON_CRIT,
	WEAPON_BYPASS_SHIELD,
	WEAPON_CHANNELING_DAMAGE,
	WEAPON_CHANNELING_EFFICIENCY,
	WEAPON_CHARGE_RATE,
	WEAPON_CLIP_MAX,
	WEAPON_CONVERT_AMMO_DELAY,
	WEAPON_CONVERT_AMMO,
	WEAPON_CORPSE_EXPLODE_DAMAGE_ENEMY_HEALTH_PCT,
	WEAPON_CORPSE_EXPLODE_DAMAGE,
	WEAPON_CORPSE_EXPLODE_PROC_CHANCE,
	WEAPON_CORPSE_EXPLODE_RADIUS,
	WEAPON_CRIT_CHANCE_BODY_PART,
	WEAPON_CRIT_CHANCE,
	WEAPON_CRIT_DAMAGE,
	WEAPON_CRIT_FIRE_RATE_BONUS,
	WEAPON_CRIT_FIRE_RATE_DURATION,
	WEAPON_DAMAGE_AMOUNT,
	WEAPON_DAMAGE_CONVERSION,
	WEAPON_DAMAGE_IF_VICTIM_PROC_ACTIVE,
	WEAPON_DAMAGE_OVER_DISTANCE,
	WEAPON_DAMAGE_SELF_AMOUNT,
	WEAPON_DAMAGE_TO_ENERGY,
	WEAPON_DAMAGE_TO_HEALTH,
	WEAPON_DAMAGE_TO_XP,
	WEAPON_DAMAGE_TYPE_BIAS,
	WEAPON_DISTANCE_TO_DAMAGE_BONUS,
	WEAPON_DOUBLE_CRIT_CHANCE,
	WEAPON_DRAIN_MAX,
	WEAPON_EMPLACEMENT_AMMO_CONSUME_RATE,
	WEAPON_ENERGY_ON_HEADSHOT_KILL,
	WEAPON_EXPLOSION_RADIUS,
	WEAPON_EXTRA_SCAN_CHANCE,
	WEAPON_FIRE_ITERATIONS,
	WEAPON_FIRE_RATE,
	WEAPON_FIRE_REDIRECT_PROC_CHANCE,
	WEAPON_FIRE_REDIRECT_PROC_TYPE,
	WEAPON_FIRE_REDIRECT_RANGE,
	WEAPON_FORCED_PROC_CHANCE,
	WEAPON_GORE_CHANCE,
	WEAPON_GRENADE_STICKY,
	WEAPON_HEADSHOT_MULTIPLIER,
	WEAPON_HEALTH_ON_HIT_ENEMY_WITH_PROC,
	WEAPON_HEALTH_ON_KILL_CHANCE,
	WEAPON_HEALTH_ON_KILL,
	WEAPON_HOLSTER_RATE,
	WEAPON_HOLSTERED_AUTO_RELOAD_RATE,
	WEAPON_INFINITE_CLIP_MOD,
	WEAPON_INIT_DAMAGE_MOD,
	WEAPON_KILL_TO_STAMINA,
	WEAPON_KNOCKDOWN_TIME,
	WEAPON_LAST_DAMAGE_MOD,
	WEAPON_LIFE_STEAL_CHANNELING,
	WEAPON_LIFE_STEAL,
	WEAPON_LOCK_TIME,
	WEAPON_MARK_TARGET,
	WEAPON_MELEE_ARMOR_REDUCTION,
	WEAPON_MELEE_AUTOTARGET_MAXIMUM_ANGLE,
	WEAPON_MELEE_AUTOTARGET_RANGE_BONUS,
	WEAPON_MELEE_AUTOTARGET_SPEED_BONUS,
	WEAPON_MELEE_COMBO_CHANCE_FROM_DOT,
	WEAPON_MELEE_COMBO_CRIT_CHANCE,
	WEAPON_MELEE_COMBO_DECAY_AMOUNT,
	WEAPON_MELEE_COMBO_DURATION_BONUS,
	WEAPON_MELEE_COMBO_GAIN_EXTRA_CHANCE,
	WEAPON_MELEE_COMBO_GAIN_MISS_CHANCE,
	WEAPON_MELEE_COMBO_HIT_BONUS,
	WEAPON_MELEE_COMBO_INITIAL_BONUS,
	WEAPON_MELEE_COMBO_MULTIPLIER_BONUS,
	WEAPON_MELEE_COMBO_MULTIPLIER_CRIT_CHANCE,
	WEAPON_MELEE_COMBO_MULTIPLIER_PROC_CHANCE,
	WEAPON_MELEE_COMBO_PROC_CHANCE,
	WEAPON_MELEE_COMBO_USAGE_EFFICIENCY,
	WEAPON_MELEE_DAMAGE,
	WEAPON_MELEE_FINISHER_DAMAGE,
	WEAPON_MELEE_HEAVY_CHARGE_SPEED,
	WEAPON_MELEE_HIT_GROUND_TARGET,
	WEAPON_MELEE_SLAM_DAMAGE_BONUS,
	WEAPON_MELEE_STAMINA_PENALTY,
	WEAPON_MELEE_STEALTH_LETHAL,
	WEAPON_MICROWAVE_PROC_CRIT_CHANCE_BONUS,
	WEAPON_MODE_SWITCH_SPEED,
	WEAPON_NOISE_REDUCTION,
	WEAPON_NULLIFIER_BUBBLE_POP_CHANCE,
	WEAPON_OVERHEAT_DAMAGE,
	WEAPON_OVERHEAT_PROC_CHANCE,
	WEAPON_PARRY_ANGLE,
	WEAPON_PARRY_COUNTER_CHANCE_STAGGER,
	WEAPON_PARRY_COUNTER_CHANCE_STUN,
	WEAPON_PARRY_COUNTER_CHANCE,
	WEAPON_PARRY_DAMAGE_BLOCKED,
	WEAPON_PARRY_DAMAGE_REFLECTED,
	WEAPON_PARRY_DAMAGE_TO_STAMINA,
	WEAPON_PARRY_EFFECTIVENESS,
	WEAPON_PARRY_EFFICIENCY,
	WEAPON_PERCENT_BASE_DAMAGE_ADDED_POST_COALESCE,
	WEAPON_PERCENT_BASE_DAMAGE_ADDED,
	WEAPON_PERCENT_BASE_INNATE_DAMAGE_ADDED,
	WEAPON_PICKUP_SHOOT_BONUS,
	WEAPON_POWER_DAMAGE_BLOCK,
	WEAPON_POWER_DAMAGE_MAX,
	WEAPON_POWER_DAMAGE_MULTIPLIER,
	WEAPON_PROC_ACTIVE_BONUS_DAMAGE,
	WEAPON_PROC_CHANCE,
	WEAPON_PROC_DAMAGE,
	WEAPON_PROC_SELF_CC_REDUCTION_CHANCE,
	WEAPON_PROC_TIME_EXTEND_ON_HIT,
	WEAPON_PROC_TIME,
	WEAPON_PROJECTILE_BOUNCES,
	WEAPON_PROJECTILE_ELASTICITY,
	WEAPON_PROJECTILE_EXPLOSION_CHANCE,
	WEAPON_PROJECTILE_LINGERING_AOE_DAMAGE,
	WEAPON_PROJECTILE_LINGERING_AOE_DURATION,
	WEAPON_PROJECTILE_LINGERING_AOE_RADIUS,
	WEAPON_PROJECTILE_SPEED,
	WEAPON_PUNCTURE_DEPTH,
	WEAPON_RANGE,
	WEAPON_RECOIL,
	WEAPON_REFLECTION_EXPLOSION_CHANCE,
	WEAPON_REFLECTION_MODIFIER,
	WEAPON_RELOAD_EMPTY_BATTERY,
	WEAPON_RELOAD_SPEED,
	WEAPON_RELOAD_TIME,
	WEAPON_RICHOCET_CHANCE,
	WEAPON_SHIELD_ON_KILL_CHANCE,
	WEAPON_SHIELD_ON_KILL,
	WEAPON_SLASH_PROC_ON_CRIT_CHANCE,
	WEAPON_SLASH_PROC_ON_IMPACT,
	WEAPON_SNIPER_COMBO_CRIT_CHANCE,
	WEAPON_SNIPER_COMBO_DURATION_BONUS,
	WEAPON_SNIPER_COMBO_HIT_BONUS,
	WEAPON_SNIPER_COMBO_MULTIPLIER_BONUS,
	WEAPON_SNIPER_COMBO_PROC_CHANCE,
	WEAPON_SPREAD,
	WEAPON_SYNDICATE_POWER,
	WEAPON_TARGET_AMOUNT,
	WEAPON_UPGRADE_SLOT,
	WEAPON_VICTIM_STAMINA_DRAIN_PERCENTAGE,
	WEAPON_ZOOM_SHAKE_SPEED,
	WEAPON_ZOOM,
}

export enum PostureModifier {
	PM_AIM = 0,
	PM_AIM_MAIN_HAND = 1,
	PM_AIM_OFF_HAND = 2,
	PM_FREE_FIRED = 3,
	PM_DODGE = 4,
	PM_BLOCKING_ANIM = 5,
	PM_STUN = 6,
	PM_CLOAK = 7,
	PM_ANIMATION_CONTROLLED = 8,
	PM_HIBERNATE = 9,
	PM_EXPLODE = 10,
	PM_FINISHER_OPEN = 11,
	PM_KNOCKDOWN = 12,
	PM_STAGGER = 13,
	PM_PRE_DEATH = 14,
	PM_IN_AIR = 15,
	PM_MENACE = 16,
	PM_CARRYING = 17,
	PM_ALT_AIM_RIGHT = 18,
	PM_ALT_AIM_LEFT = 19,
	PM_HELD = 20,
	PM_GROUNDFIRE = 21,
	PM_ALTERNATE_COVER = 22,
	PM_CRIPPLED = 23,
	PM_WALLJUMP = 24,
	PM_BULLETJUMP = 25,
	PM_PARRY = 26,
	PM_GRAV_DISABLED = 27,
	PM_EMPLACEMENT = 28,
	PM_AIRBORNE = 29,
	PM_HEAVY_MELEE = 30,
	PM_MELEE_RAGE = 31,
}

export enum Posture {
	WALK = 0,
	JOG = 1,
	RUN = 2,
	STAND = 3,
	CROUCH = 4,
	SLIDE = 5,
	CONTEXT_JUMP = 6,
	LADDER = 7,
	WALL_COVER_LEFT = 8,
	WALL_COVER_RIGHT = 9,
	CROUCH_COVER_LEFT = 10,
	CROUCH_COVER_RIGHT = 11,
	HOLD_LEDGE = 12,
	HANG_LEDGE = 13,
	JUMPINTERRUPT_THEN_HOLD = 14,
	JUMPINTERRUPT_THEN_HANG = 15,
	JUMPINTERRUPT_THEN_MANTLE = 16,
	GROUND_FIRE = 17,
	BEHIND_SHIELD = 18,
	ZIPLINING = 19,
	WALLRUNNING_LEFT = 20,
	WALLRUNNING_RIGHT = 21,
	WALLRUNNING_UP = 22,
	GRAPPLINGHOOK_SLIDING = 23,
	GRAPPLINGHOOK_HOLDING_WALL = 24,
	GRAPPLINGHOOK_HOLDING_CEILING = 25,
}

// Determined from the codex currently, not directly from the entries
export enum ItemType {
	Misc = "Misc",
	Mod = "Mod",
	Relic = "Relic",
	RelicsAndArcanes = "RelicsAndArcanes",
	Warframe = "Warframe",
	Weapon = "Weapon",
	WeaponParts = "WeaponParts",
	Sentinel = "Sentinel",
	SentinelWeapon = "SentinelWeapon",
}

export enum ProductCategory {
	Hoverboards = "Hoverboards",
	Kitguns = "Kitguns",
	KubrowPets = "KubrowPets",
	LongGuns = "LongGuns",
	MechSuits = "MechSuits",
	Melee = "Melee",
	MoaPets = "MoaPets",
	OperatorAmps = "OperatorAmps",
	Pistols = "Pistols",
	Sentinels = "Sentinels",
	SentinelWeapons = "SentinelWeapons",
	SpaceGuns = "SpaceGuns",
	SpaceMelee = "SpaceMelee",
	SpaceSuits = "SpaceSuits",
	SpecialItems = "SpecialItems",
	Suits = "Suits",
	Upgrades = "Upgrades",
	WeaponSkins = "WeaponSkins",
	Zaws = "Zaws",
}

export enum SlotType {
	NORMAL,
	AURA,
	STANCE,
	EXILUS,
	ARCANE,
}

export enum SlotPolarity {
	INVALID,
	NEUTRAL,
	MATCH,
	MISMATCH,
}

export enum RelicQuality {
	VPQ_BRONZE = "VPQ_BRONZE",
	VPQ_SILVER = "VPQ_SILVER",
	VPQ_GOLD = "VPQ_GOLD",
	VPQ_PLATINUM = "VPQ_PLATINUM",
}

export type MarketMode = "MM_NONE" | "MM_HIDDEN" | "MM_EXCLUDED" | "MM_VISIBLE";

export type ComponentCategory = "CC_FOUNDRY" | "CC_RESEARCH" | "CC_ARCHIVE" | "CC_ANY";

// custom enum
export enum ModUsability {
	INVALID,
	PVE_ONLY,
	PVP_ONLY,
	UNIVERSAL,
}

export enum InventorySlot {
	SLOT_1 = "SLOT_1", // Secondary
	SLOT_2 = "SLOT_2", // Primary
	SLOT_3 = "SLOT_3", // Fishing Spears, equipment
	SLOT_4 = "SLOT_4", // Warframe
	SLOT_5 = "SLOT_5", // Pickup Item (eg. powercell)
	SLOT_6 = "SLOT_6", // Melee
	SLOT_7 = "SLOT_7", // Archwing
	SLOT_8 = "SLOT_8", // Exalted Weapon
}

export type PHYSICAL_DAMAGE_TYPE = "DT_IMPACT" | "DT_PUNCTURE" | "DT_SLASH";
export const PHYSICAL_DAMAGE_TYPES: PHYSICAL_DAMAGE_TYPE[] = [
	"DT_IMPACT",
	"DT_PUNCTURE",
	"DT_SLASH",
];

export const ELEMENTAL_DAMAGE_TYPES: Array<keyof typeof DamageType> = [
	"DT_FIRE",
	"DT_FREEZE",
	"DT_ELECTRICITY",
	"DT_POISON",
];

// Modular item parts (kitguns, zaws, amps, moas, hoverboards)
export enum ModularPartType {
	LWPT_HILT = "LWPT_HILT",
	LWPT_BLADE = "LWPT_BLADE",
	LWPT_HILT_WEIGHT = "LWPT_HILT_WEIGHT",
	LWPT_AMP_BRACE = "LWPT_AMP_BRACE",
	LWPT_AMP_CORE = "LWPT_AMP_CORE",
	LWPT_AMP_OCULUS = "LWPT_AMP_OCULUS",
	LWPT_GUN_PRIMARY_HANDLE = "LWPT_GUN_PRIMARY_HANDLE",
	LWPT_GUN_SECONDARY_HANDLE = "LWPT_GUN_SECONDARY_HANDLE",
	LWPT_GUN_BARREL = "LWPT_GUN_BARREL",
	LWPT_GUN_CLIP = "LWPT_GUN_CLIP",
	LWPT_MOA_LEG = "LWPT_MOA_LEG",
	LWPT_MOA_HEAD = "LWPT_MOA_HEAD",
	LWPT_MOA_ENGINE = "LWPT_MOA_ENGINE",
	LWPT_MOA_PAYLOAD = "LWPT_MOA_PAYLOAD",
	LWPT_HB_DECK = "LWPT_HB_DECK",
	LWPT_HB_ENGINE = "LWPT_HB_ENGINE",
	LWPT_HB_FRONT = "LWPT_HB_FRONT",
	LWPT_HB_JET = "LWPT_HB_JET",
	LWPT_INVALID = "LWPT_INVALID",
	LWPT_ZANUKA_HEAD = "LWPT_ZANUKA_HEAD",
}

export enum KitgunGunType {
	GT_RIFLE = "GT_RIFLE",
	GT_SHOTGUN = "GT_SHOTGUN",
	GT_SNIPER = "GT_SNIPER",
	GT_LAUNCHER = "GT_LAUNCHER",
	GT_BEAM = "GT_BEAM",
	GT_NONE = "GT_NONE",
}

export enum KitgunBarrelType {
	BT_AUTO_HITSCAN = "BT_AUTO_HITSCAN",
	BT_AUTO_PROJECTILE = "BT_AUTO_PROJECTILE",
	BT_SEMI_HITSCAN = "BT_SEMI_HITSCAN",
	BT_SEMI_PROJECTILE = "BT_SEMI_PROJECTILE",
	BT_BURST_HITSCAN = "BT_BURST_HITSCAN",
	BT_BURST_PROJECTILE = "BT_BURST_PROJECTILE",
	BT_NONE = "BT_NONE",
}

export enum ResistanceKeyword {
	RK_NONE,
	RK_ARMOR, // Default Grineer Ferrite Armor?
	RK_CLONED_FLESH, // HealthResistanceKeyword (Most Grineer)
	RK_MACHINERY, // HealthResistanceKeyword (Grineer Drones, Cameras)
	RK_HULKING_ARMOR, // Boss Alloy Armor, ArmourResistanceKeyword
	RK_SHIELD, // Default Corpus ShieldResistanceKeyword ?
	RK_FLESH, // Default Corpus HealthResistanceKeyword ?
	RK_ROBOTIC, // HealthResistanceKeyword (Most Corpus)
	RK_HEAVY_SHIELD, // Corpus Proto Shield, ShieldResistanceKeyword
	RK_INFESTED_FLESH, // HealthResistanceKeyword (Infested)
	RK_INFESTED, // HealthResistanceKeyword (Juggernaut?)
	RK_INFESTED_ARMOUR, // ArmourResistanceKeyword
	RK_FOSSILIZED, // HealthResistanceKeyword (Golem)
	RK_TENNO_FLESH, // HealthResistanceKeyword
	RK_TENNO_ARMOR, // ArmourResistanceKeyword
	RK_TENNO_SHIELD, // ShieldResistanceKeyword
}

export enum ProcType {
	PT_KNOCKBACK,
	PT_FRAILTY,
	PT_BLEEDING,
	PT_IMMOLATION,
	PT_CHILLED,
	PT_ELECTROCUTION,
	PT_POISONED,
	PT_FLASHBANG,
	PT_RAD_TOX,
	PT_ASPHYXIATION,
	PT_MAGNETIZED,
	PT_INFECTED,
	PT_CAUSTIC_BURN,
	PT_RADIANT,
	PT_SENTIENT,
	PT_MICROWAVE_BURN,
	PT_STAGGERED,
	PT_BIG_STAGGER,
	PT_STUNNED,
	PT_KNOCKED_DOWN,
	PT_RAGDOLL,
	PT_PARRIED,
	PT_DISARMED,
	PT_SILENCED,
	PT_ROOTS,
	PT_VOID,
	PT_GLUE,
	PT_SLEEP,
	PT_LIFT_HIT,
}

export enum DamageHitType {
	DHT_NONE,
	DHT_TRACE,
	DHT_PROJECTILE,
	DHT_MELEE,
	DHT_RADIAL,
	DHT_SCRIPT,
	DHT_LINK,
	DHT_DOT,
}

export enum RoundingMode {
	RM_CEILING = "RM_CEILING",
	RM_FLOOR = "RM_FLOOR",
	RM_ROUND = "RM_ROUND",
}
